module IndRec where

open import Data.Nat
open import Data.Product
open import Data.Unit
open import Data.Empty
-- open import Data.Fin hiding (lift)

data Codes : Set where nat pi pruni lift : Codes

mutual 

  U' : ℕ → Codes → ℕ → Set
  U' n nat k       = ⊤
  U' n pi  zero    = ⊥
  U' n pi  (suc k) = ∃ λ (a : U n k) → El n k a → U n k
  U' n pruni k     = ⊤
  U' zero    lift k = ⊥
  U' (suc n) lift k = ∃ λ k' → U n k'

  U : ℕ → ℕ → Set
  U n k = ∃ λ c → U' n c k

  El : (n k : ℕ) → U n k → Set
  El n k       (nat , _)       = ℕ  
  El n zero    (pi , ())
  El n (suc k) (pi , a , f)    = (x : El n k a) -> El n k (f x)
  El zero k    (lift , ()) 
  El (suc n) k (lift , k' , a) = El n k' a
  El zero k    (pruni , _)     = ⊥
  El (suc n) k (pruni , _)     = U n k 

{-
Lift : {n k : ℕ}(k' : ℕ) → U n k' → U (suc n) k
Lift k' c = lift , k' , c
-}

PolyId : U 1 2
PolyId = pi , (pruni , tt) , λ a → pi , (lift , 1 , a) , λ x → lift , 1 , a

polyId : El 1 2 PolyId
polyId = λ a x → x
